Index: uspace/lib/ext4/include/ext4/filesystem.h
===================================================================
--- uspace/lib/ext4/include/ext4/filesystem.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/ext4/include/ext4/filesystem.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -39,8 +39,8 @@
 #include "ext4/types.h"
 
-extern errno_t ext4_filesystem_probe(service_id_t);
-extern errno_t ext4_filesystem_open(ext4_instance_t *, service_id_t,
+extern int ext4_filesystem_probe(service_id_t);
+extern int ext4_filesystem_open(ext4_instance_t *, service_id_t,
     enum cache_mode, aoff64_t *, ext4_filesystem_t **);
-extern errno_t ext4_filesystem_close(ext4_filesystem_t *);
+extern int ext4_filesystem_close(ext4_filesystem_t *);
 extern uint32_t ext4_filesystem_blockaddr2_index_in_group(ext4_superblock_t *,
     uint32_t);
@@ -48,20 +48,20 @@
     uint32_t, uint32_t);
 extern uint32_t ext4_filesystem_blockaddr2group(ext4_superblock_t *, uint64_t);
-extern errno_t ext4_filesystem_get_block_group_ref(ext4_filesystem_t *, uint32_t,
+extern int ext4_filesystem_get_block_group_ref(ext4_filesystem_t *, uint32_t,
     ext4_block_group_ref_t **);
-extern errno_t ext4_filesystem_put_block_group_ref(ext4_block_group_ref_t *);
-extern errno_t ext4_filesystem_get_inode_ref(ext4_filesystem_t *, uint32_t,
+extern int ext4_filesystem_put_block_group_ref(ext4_block_group_ref_t *);
+extern int ext4_filesystem_get_inode_ref(ext4_filesystem_t *, uint32_t,
     ext4_inode_ref_t **);
-extern errno_t ext4_filesystem_put_inode_ref(ext4_inode_ref_t *);
-extern errno_t ext4_filesystem_alloc_inode(ext4_filesystem_t *, ext4_inode_ref_t **,
+extern int ext4_filesystem_put_inode_ref(ext4_inode_ref_t *);
+extern int ext4_filesystem_alloc_inode(ext4_filesystem_t *, ext4_inode_ref_t **,
     int);
-extern errno_t ext4_filesystem_free_inode(ext4_inode_ref_t *);
-extern errno_t ext4_filesystem_truncate_inode(ext4_inode_ref_t *, aoff64_t);
-extern errno_t ext4_filesystem_get_inode_data_block_index(ext4_inode_ref_t *,
+extern int ext4_filesystem_free_inode(ext4_inode_ref_t *);
+extern int ext4_filesystem_truncate_inode(ext4_inode_ref_t *, aoff64_t);
+extern int ext4_filesystem_get_inode_data_block_index(ext4_inode_ref_t *,
     aoff64_t iblock, uint32_t *);
-extern errno_t ext4_filesystem_set_inode_data_block_index(ext4_inode_ref_t *,
+extern int ext4_filesystem_set_inode_data_block_index(ext4_inode_ref_t *,
     aoff64_t, uint32_t);
-extern errno_t ext4_filesystem_release_inode_block(ext4_inode_ref_t *, uint32_t);
-extern errno_t ext4_filesystem_append_inode_block(ext4_inode_ref_t *, uint32_t *,
+extern int ext4_filesystem_release_inode_block(ext4_inode_ref_t *, uint32_t);
+extern int ext4_filesystem_append_inode_block(ext4_inode_ref_t *, uint32_t *,
     uint32_t *);
 uint32_t ext4_filesystem_bg_get_backup_blocks(ext4_block_group_ref_t *bg);
Index: uspace/lib/ext4/include/ext4/hash.h
===================================================================
--- uspace/lib/ext4/include/ext4/hash.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/ext4/include/ext4/hash.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,5 +36,5 @@
 #include "ext4/types.h"
 
-extern errno_t ext4_hash_string(ext4_hash_info_t *, int, const char *);
+extern int ext4_hash_string(ext4_hash_info_t *, int, const char *);
 
 #endif
Index: uspace/lib/ext4/include/ext4/ialloc.h
===================================================================
--- uspace/lib/ext4/include/ext4/ialloc.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/ext4/include/ext4/ialloc.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,6 +36,6 @@
 #include "ext4/types.h"
 
-extern errno_t ext4_ialloc_free_inode(ext4_filesystem_t *, uint32_t, bool);
-extern errno_t ext4_ialloc_alloc_inode(ext4_filesystem_t *, uint32_t *, bool);
+extern int ext4_ialloc_free_inode(ext4_filesystem_t *, uint32_t, bool);
+extern int ext4_ialloc_alloc_inode(ext4_filesystem_t *, uint32_t *, bool);
 
 #endif
Index: uspace/lib/ext4/include/ext4/inode.h
===================================================================
--- uspace/lib/ext4/include/ext4/inode.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/ext4/include/ext4/inode.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -59,5 +59,5 @@
 extern uint64_t ext4_inode_get_blocks_count(ext4_superblock_t *,
     ext4_inode_t *);
-extern errno_t ext4_inode_set_blocks_count(ext4_superblock_t *, ext4_inode_t *,
+extern int ext4_inode_set_blocks_count(ext4_superblock_t *, ext4_inode_t *,
     uint64_t);
 extern uint32_t ext4_inode_get_flags(ext4_inode_t *);
@@ -73,5 +73,5 @@
 extern uint32_t ext4_inode_get_indirect_block(ext4_inode_t *, uint32_t);
 extern void ext4_inode_set_indirect_block(ext4_inode_t *, uint32_t, uint32_t);
-extern ext4_extent_header_t *ext4_inode_get_extent_header(ext4_inode_t *);
+extern ext4_extent_header_t * ext4_inode_get_extent_header(ext4_inode_t *);
 extern bool ext4_inode_is_type(ext4_superblock_t *, ext4_inode_t *, uint32_t);
 extern bool ext4_inode_has_flag(ext4_inode_t *, uint32_t);
Index: uspace/lib/ext4/include/ext4/ops.h
===================================================================
--- uspace/lib/ext4/include/ext4/ops.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/ext4/include/ext4/ops.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -40,9 +40,9 @@
 extern libfs_ops_t ext4_libfs_ops;
 
-extern errno_t ext4_global_init(void);
-extern errno_t ext4_global_fini(void);
+extern int ext4_global_init(void);
+extern int ext4_global_fini(void);
 
-extern errno_t ext4_node_get_core(fs_node_t **, ext4_instance_t *, fs_index_t);
-extern errno_t ext4_node_put(fs_node_t *);
+extern int ext4_node_get_core(fs_node_t **, ext4_instance_t *, fs_index_t);
+extern int ext4_node_put(fs_node_t *);
 
 
Index: uspace/lib/ext4/include/ext4/superblock.h
===================================================================
--- uspace/lib/ext4/include/ext4/superblock.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/ext4/include/ext4/superblock.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -113,14 +113,14 @@
     uint32_t);
 
-extern const uint8_t *ext4_superblock_get_uuid(ext4_superblock_t *);
+extern const uint8_t * ext4_superblock_get_uuid(ext4_superblock_t *);
 extern void ext4_superblock_set_uuid(ext4_superblock_t *, const uint8_t *);
-extern const char *ext4_superblock_get_volume_name(ext4_superblock_t *);
+extern const char * ext4_superblock_get_volume_name(ext4_superblock_t *);
 extern void ext4_superblock_set_volume_name(ext4_superblock_t *, const char *);
-extern const char *ext4_superblock_get_last_mounted(ext4_superblock_t *);
+extern const char * ext4_superblock_get_last_mounted(ext4_superblock_t *);
 extern void ext4_superblock_set_last_mounted(ext4_superblock_t *, const char *);
 
 extern uint32_t ext4_superblock_get_last_orphan(ext4_superblock_t *);
 extern void ext4_superblock_set_last_orphan(ext4_superblock_t *, uint32_t);
-extern const uint32_t *ext4_superblock_get_hash_seed(ext4_superblock_t *);
+extern const uint32_t * ext4_superblock_get_hash_seed(ext4_superblock_t *);
 extern void ext4_superblock_set_hash_seed(ext4_superblock_t *,
     const uint32_t *);
@@ -152,8 +152,8 @@
 extern bool ext4_superblock_has_feature_read_only(ext4_superblock_t *,
     uint32_t);
-extern errno_t ext4_superblock_read_direct(service_id_t, ext4_superblock_t **);
-extern errno_t ext4_superblock_write_direct(service_id_t, ext4_superblock_t *);
+extern int ext4_superblock_read_direct(service_id_t, ext4_superblock_t **);
+extern int ext4_superblock_write_direct(service_id_t, ext4_superblock_t *);
 extern void ext4_superblock_release(ext4_superblock_t *);
-extern errno_t ext4_superblock_check_sanity(ext4_superblock_t *);
+extern int ext4_superblock_check_sanity(ext4_superblock_t *);
 
 extern uint32_t ext4_superblock_get_block_group_count(ext4_superblock_t *);
Index: uspace/lib/ext4/include/ext4/types.h
===================================================================
--- uspace/lib/ext4/include/ext4/types.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/ext4/include/ext4/types.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -476,4 +476,5 @@
 } ext4_directory_dx_block_t;
 
+#define EXT4_ERR_BAD_DX_DIR       (-75000)
 #define EXT4_DIRECTORY_HTREE_EOF  UINT32_C(0x7fffffff)
 
Index: uspace/lib/ext4/src/balloc.c
===================================================================
--- uspace/lib/ext4/src/balloc.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/ext4/src/balloc.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -53,5 +53,5 @@
  *
  */
-errno_t ext4_balloc_free_block(ext4_inode_ref_t *inode_ref, uint32_t block_addr)
+int ext4_balloc_free_block(ext4_inode_ref_t *inode_ref, uint32_t block_addr)
 {
 	ext4_filesystem_t *fs = inode_ref->fs;
@@ -65,5 +65,5 @@
 	/* Load block group reference */
 	ext4_block_group_ref_t *bg_ref;
-	errno_t rc = ext4_filesystem_get_block_group_ref(fs, block_group, &bg_ref);
+	int rc = ext4_filesystem_get_block_group_ref(fs, block_group, &bg_ref);
 	if (rc != EOK)
 		return rc;
@@ -118,5 +118,5 @@
 }
 
-static errno_t ext4_balloc_free_blocks_internal(ext4_inode_ref_t *inode_ref,
+static int ext4_balloc_free_blocks_internal(ext4_inode_ref_t *inode_ref,
     uint32_t first, uint32_t count)
 {
@@ -134,5 +134,5 @@
 	/* Load block group reference */
 	ext4_block_group_ref_t *bg_ref;
-	errno_t rc = ext4_filesystem_get_block_group_ref(fs, block_group_first, &bg_ref);
+	int rc = ext4_filesystem_get_block_group_ref(fs, block_group_first, &bg_ref);
 	if (rc != EOK)
 		return rc;
@@ -198,8 +198,8 @@
  *
  */
-errno_t ext4_balloc_free_blocks(ext4_inode_ref_t *inode_ref,
+int ext4_balloc_free_blocks(ext4_inode_ref_t *inode_ref,
     uint32_t first, uint32_t count)
 {
-	errno_t r;
+	int r;
 	uint32_t gid;
 	uint64_t limit;
@@ -293,5 +293,5 @@
  *
  */
-static errno_t ext4_balloc_find_goal(ext4_inode_ref_t *inode_ref, uint32_t *goal)
+static int ext4_balloc_find_goal(ext4_inode_ref_t *inode_ref, uint32_t *goal)
 {
 	*goal = 0;
@@ -307,5 +307,5 @@
 	/* If inode has some blocks, get last block address + 1 */
 	if (inode_block_count > 0) {
-		errno_t rc = ext4_filesystem_get_inode_data_block_index(inode_ref,
+		int rc = ext4_filesystem_get_inode_data_block_index(inode_ref,
 		    inode_block_count - 1, goal);
 		if (rc != EOK)
@@ -325,5 +325,5 @@
 	/* Load block group reference */
 	ext4_block_group_ref_t *bg_ref;
-	errno_t rc = ext4_filesystem_get_block_group_ref(inode_ref->fs,
+	int rc = ext4_filesystem_get_block_group_ref(inode_ref->fs,
 	    block_group, &bg_ref);
 	if (rc != EOK)
@@ -343,5 +343,5 @@
  *
  */
-errno_t ext4_balloc_alloc_block(ext4_inode_ref_t *inode_ref, uint32_t *fblock)
+int ext4_balloc_alloc_block(ext4_inode_ref_t *inode_ref, uint32_t *fblock)
 {
 	uint32_t allocated_block = 0;
@@ -354,5 +354,5 @@
 	
 	/* Find GOAL */
-	errno_t rc = ext4_balloc_find_goal(inode_ref, &goal);
+	int rc = ext4_balloc_find_goal(inode_ref, &goal);
 	if (rc != EOK)
 		return rc;
@@ -625,8 +625,8 @@
  *
  */
-errno_t ext4_balloc_try_alloc_block(ext4_inode_ref_t *inode_ref, uint32_t fblock,
+int ext4_balloc_try_alloc_block(ext4_inode_ref_t *inode_ref, uint32_t fblock,
     bool *free)
 {
-	errno_t rc;
+	int rc;
 	
 	ext4_filesystem_t *fs = inode_ref->fs;
Index: uspace/lib/ext4/src/bitmap.c
===================================================================
--- uspace/lib/ext4/src/bitmap.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/ext4/src/bitmap.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -169,5 +169,5 @@
  *
  */
-errno_t ext4_bitmap_find_free_byte_and_set_bit(uint8_t *bitmap, uint32_t start,
+int ext4_bitmap_find_free_byte_and_set_bit(uint8_t *bitmap, uint32_t start,
     uint32_t *index, uint32_t max)
 {
@@ -211,5 +211,5 @@
  *
  */
-errno_t ext4_bitmap_find_free_bit_and_set(uint8_t *bitmap, uint32_t start_idx,
+int ext4_bitmap_find_free_bit_and_set(uint8_t *bitmap, uint32_t start_idx,
     uint32_t *index, uint32_t max)
 {
Index: uspace/lib/ext4/src/directory.c
===================================================================
--- uspace/lib/ext4/src/directory.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/ext4/src/directory.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -169,6 +169,6 @@
 }
 
-static errno_t ext4_directory_iterator_seek(ext4_directory_iterator_t *, aoff64_t);
-static errno_t ext4_directory_iterator_set(ext4_directory_iterator_t *, uint32_t);
+static int ext4_directory_iterator_seek(ext4_directory_iterator_t *, aoff64_t);
+static int ext4_directory_iterator_set(ext4_directory_iterator_t *, uint32_t);
 
 /** Initialize directory iterator.
@@ -183,5 +183,5 @@
  *
  */
-errno_t ext4_directory_iterator_init(ext4_directory_iterator_t *it,
+int ext4_directory_iterator_init(ext4_directory_iterator_t *it,
     ext4_inode_ref_t *inode_ref, aoff64_t pos)
 {
@@ -201,5 +201,5 @@
  *
  */
-errno_t ext4_directory_iterator_next(ext4_directory_iterator_t *it)
+int ext4_directory_iterator_next(ext4_directory_iterator_t *it)
 {
 	assert(it->current != NULL);
@@ -220,5 +220,5 @@
  *
  */
-errno_t ext4_directory_iterator_seek(ext4_directory_iterator_t *it, aoff64_t pos)
+int ext4_directory_iterator_seek(ext4_directory_iterator_t *it, aoff64_t pos)
 {
 	uint64_t size = ext4_inode_get_size(it->inode_ref->fs->superblock,
@@ -231,5 +231,5 @@
 	if (pos >= size) {
 		if (it->current_block) {
-			errno_t rc = block_put(it->current_block);
+			int rc = block_put(it->current_block);
 			it->current_block = NULL;
 			
@@ -255,5 +255,5 @@
 	    (current_block_idx != next_block_idx)) {
 		if (it->current_block) {
-			errno_t rc = block_put(it->current_block);
+			int rc = block_put(it->current_block);
 			it->current_block = NULL;
 			
@@ -263,5 +263,5 @@
 		
 		uint32_t next_block_phys_idx;
-		errno_t rc = ext4_filesystem_get_inode_data_block_index(it->inode_ref,
+		int rc = ext4_filesystem_get_inode_data_block_index(it->inode_ref,
 		    next_block_idx, &next_block_phys_idx);
 		if (rc != EOK)
@@ -289,5 +289,5 @@
  *
  */
-static errno_t ext4_directory_iterator_set(ext4_directory_iterator_t *it,
+static int ext4_directory_iterator_set(ext4_directory_iterator_t *it,
     uint32_t block_size)
 {
@@ -331,5 +331,5 @@
  *
  */
-errno_t ext4_directory_iterator_fini(ext4_directory_iterator_t *it)
+int ext4_directory_iterator_fini(ext4_directory_iterator_t *it)
 {
 	it->inode_ref = NULL;
@@ -386,5 +386,5 @@
  *
  */
-errno_t ext4_directory_add_entry(ext4_inode_ref_t *parent, const char *name,
+int ext4_directory_add_entry(ext4_inode_ref_t *parent, const char *name,
     ext4_inode_ref_t *child)
 {
@@ -395,5 +395,5 @@
 	    EXT4_FEATURE_COMPAT_DIR_INDEX)) &&
 	    (ext4_inode_has_flag(parent->inode, EXT4_INODE_FLAG_INDEX))) {
-		errno_t rc = ext4_directory_dx_add_entry(parent, child, name);
+		int rc = ext4_directory_dx_add_entry(parent, child, name);
 
 		/* Check if index is not corrupted */
@@ -419,5 +419,5 @@
 	bool success = false;
 	for (iblock = 0; iblock < total_blocks; ++iblock) {
-		errno_t rc = ext4_filesystem_get_inode_data_block_index(parent,
+		int rc = ext4_filesystem_get_inode_data_block_index(parent,
 		    iblock, &fblock);
 		if (rc != EOK)
@@ -447,5 +447,5 @@
 	iblock = 0;
 	fblock = 0;
-	errno_t rc = ext4_filesystem_append_inode_block(parent, &fblock, &iblock);
+	int rc = ext4_filesystem_append_inode_block(parent, &fblock, &iblock);
 	if (rc != EOK)
 		return rc;
@@ -479,5 +479,5 @@
  *
  */
-errno_t ext4_directory_find_entry(ext4_directory_search_result_t *result,
+int ext4_directory_find_entry(ext4_directory_search_result_t *result,
     ext4_inode_ref_t *parent, const char *name)
 {
@@ -490,5 +490,5 @@
 	    EXT4_FEATURE_COMPAT_DIR_INDEX)) &&
 	    (ext4_inode_has_flag(parent->inode, EXT4_INODE_FLAG_INDEX))) {
-		errno_t rc = ext4_directory_dx_find_entry(result, parent, name_len,
+		int rc = ext4_directory_dx_find_entry(result, parent, name_len,
 		    name);
 		
@@ -517,5 +517,5 @@
 	for (iblock = 0; iblock < total_blocks; ++iblock) {
 		/* Load block address */
-		errno_t rc = ext4_filesystem_get_inode_data_block_index(parent, iblock,
+		int rc = ext4_filesystem_get_inode_data_block_index(parent, iblock,
 		    &fblock);
 		if (rc != EOK)
@@ -561,5 +561,5 @@
  *
  */
-errno_t ext4_directory_remove_entry(ext4_inode_ref_t *parent, const char *name)
+int ext4_directory_remove_entry(ext4_inode_ref_t *parent, const char *name)
 {
 	/* Check if removing from directory */
@@ -570,5 +570,5 @@
 	/* Try to find entry */
 	ext4_directory_search_result_t result;
-	errno_t rc = ext4_directory_find_entry(&result, parent, name);
+	int rc = ext4_directory_find_entry(&result, parent, name);
 	if (rc != EOK)
 		return rc;
@@ -626,5 +626,5 @@
  *
  */
-errno_t ext4_directory_try_insert_entry(ext4_superblock_t *sb,
+int ext4_directory_try_insert_entry(ext4_superblock_t *sb,
     block_t *target_block, ext4_inode_ref_t *child, const char *name,
     uint32_t name_len)
@@ -705,5 +705,5 @@
  *
  */
-errno_t ext4_directory_find_in_block(block_t *block, ext4_superblock_t *sb,
+int ext4_directory_find_in_block(block_t *block, ext4_superblock_t *sb,
     size_t name_len, const char *name, ext4_directory_entry_ll_t **res_entry)
 {
@@ -756,5 +756,5 @@
  *
  */
-errno_t ext4_directory_destroy_result(ext4_directory_search_result_t *result)
+int ext4_directory_destroy_result(ext4_directory_search_result_t *result)
 {
 	if (result->block)
Index: uspace/lib/ext4/src/directory_index.c
===================================================================
--- uspace/lib/ext4/src/directory_index.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/ext4/src/directory_index.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -236,9 +236,9 @@
  *
  */
-errno_t ext4_directory_dx_init(ext4_inode_ref_t *dir)
+int ext4_directory_dx_init(ext4_inode_ref_t *dir)
 {
 	/* Load block 0, where will be index root located */
 	uint32_t fblock;
-	errno_t rc = ext4_filesystem_get_inode_data_block_index(dir, 0,
+	int rc = ext4_filesystem_get_inode_data_block_index(dir, 0,
 	    &fblock);
 	if (rc != EOK)
@@ -322,5 +322,5 @@
  *
  */
-static errno_t ext4_directory_hinfo_init(ext4_hash_info_t *hinfo,
+static int ext4_directory_hinfo_init(ext4_hash_info_t *hinfo,
     block_t *root_block, ext4_superblock_t *sb, size_t name_len,
     const char *name)
@@ -384,5 +384,5 @@
  *
  */
-static errno_t ext4_directory_dx_get_leaf(ext4_hash_info_t *hinfo,
+static int ext4_directory_dx_get_leaf(ext4_hash_info_t *hinfo,
     ext4_inode_ref_t *inode_ref, block_t *root_block,
     ext4_directory_dx_block_t **dx_block, ext4_directory_dx_block_t *dx_blocks)
@@ -443,5 +443,5 @@
 		
 		uint32_t fblock;
-		errno_t rc = ext4_filesystem_get_inode_data_block_index(inode_ref,
+		int rc = ext4_filesystem_get_inode_data_block_index(inode_ref,
 		    next_block, &fblock);
 		if (rc != EOK)
@@ -484,5 +484,5 @@
  *
  */
-static errno_t ext4_directory_dx_next_block(ext4_inode_ref_t *inode_ref,
+static int ext4_directory_dx_next_block(ext4_inode_ref_t *inode_ref,
     uint32_t hash, ext4_directory_dx_block_t *dx_block,
     ext4_directory_dx_block_t *dx_blocks)
@@ -520,5 +520,5 @@
 		uint32_t block_addr;
 		
-		errno_t rc = ext4_filesystem_get_inode_data_block_index(inode_ref,
+		int rc = ext4_filesystem_get_inode_data_block_index(inode_ref,
 		    block_idx, &block_addr);
 		if (rc != EOK)
@@ -556,11 +556,11 @@
  *
  */
-errno_t ext4_directory_dx_find_entry(ext4_directory_search_result_t *result,
+int ext4_directory_dx_find_entry(ext4_directory_search_result_t *result,
     ext4_inode_ref_t *inode_ref, size_t name_len, const char *name)
 {
 	/* Load direct block 0 (index root) */
 	uint32_t root_block_addr;
-	errno_t rc2;
-	errno_t rc = ext4_filesystem_get_inode_data_block_index(inode_ref, 0,
+	int rc2;
+	int rc = ext4_filesystem_get_inode_data_block_index(inode_ref, 0,
 	    &root_block_addr);
 	if (rc != EOK)
@@ -728,9 +728,9 @@
  *
  */
-static errno_t ext4_directory_dx_split_data(ext4_inode_ref_t *inode_ref,
+static int ext4_directory_dx_split_data(ext4_inode_ref_t *inode_ref,
     ext4_hash_info_t *hinfo, block_t *old_data_block,
     ext4_directory_dx_block_t *index_block, block_t **new_data_block)
 {
-	errno_t rc = EOK;
+	int rc = EOK;
 	
 	/* Allocate buffer for directory entries */
@@ -897,5 +897,5 @@
  *
  */
-static errno_t ext4_directory_dx_split_index(ext4_inode_ref_t *inode_ref,
+static int ext4_directory_dx_split_index(ext4_inode_ref_t *inode_ref,
 		ext4_directory_dx_block_t *dx_blocks, ext4_directory_dx_block_t *dx_block)
 {
@@ -937,5 +937,5 @@
 		uint32_t new_fblock;
 		uint32_t new_iblock;
-		errno_t rc = ext4_filesystem_append_inode_block(inode_ref,
+		int rc = ext4_filesystem_append_inode_block(inode_ref,
 		    &new_fblock, &new_iblock);
 		if (rc != EOK)
@@ -1045,12 +1045,12 @@
  *
  */
-errno_t ext4_directory_dx_add_entry(ext4_inode_ref_t *parent,
+int ext4_directory_dx_add_entry(ext4_inode_ref_t *parent,
     ext4_inode_ref_t *child, const char *name)
 {
-	errno_t rc2 = EOK;
+	int rc2 = EOK;
 	
 	/* Get direct block 0 (index root) */
 	uint32_t root_block_addr;
-	errno_t rc = ext4_filesystem_get_inode_data_block_index(parent, 0,
+	int rc = ext4_filesystem_get_inode_data_block_index(parent, 0,
 	    &root_block_addr);
 	if (rc != EOK)
Index: uspace/lib/ext4/src/extent.c
===================================================================
--- uspace/lib/ext4/src/extent.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/ext4/src/extent.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -372,8 +372,8 @@
  *
  */
-errno_t ext4_extent_find_block(ext4_inode_ref_t *inode_ref, uint32_t iblock,
+int ext4_extent_find_block(ext4_inode_ref_t *inode_ref, uint32_t iblock,
     uint32_t *fblock)
 {
-	errno_t rc = EOK;
+	int rc = EOK;
 	/* Compute bound defined by i-node size */
 	uint64_t inode_size =
@@ -454,5 +454,5 @@
  *
  */
-static errno_t ext4_extent_find_extent(ext4_inode_ref_t *inode_ref, uint32_t iblock,
+static int ext4_extent_find_extent(ext4_inode_ref_t *inode_ref, uint32_t iblock,
     ext4_extent_path_t **ret_path)
 {
@@ -475,5 +475,5 @@
 	/* Walk through the extent tree */
 	uint16_t pos = 0;
-	errno_t rc;
+	int rc;
 	while (ext4_extent_header_get_depth(eh) != 0) {
 		/* Search index in index node by iblock */
@@ -515,5 +515,5 @@
 	;
 
-	errno_t rc2 = EOK;
+	int rc2 = EOK;
 
 	/*
@@ -543,5 +543,5 @@
  *
  */
-static errno_t ext4_extent_release(ext4_inode_ref_t *inode_ref,
+static int ext4_extent_release(ext4_inode_ref_t *inode_ref,
     ext4_extent_t *extent)
 {
@@ -565,5 +565,5 @@
  *
  */
-static errno_t ext4_extent_release_branch(ext4_inode_ref_t *inode_ref,
+static int ext4_extent_release_branch(ext4_inode_ref_t *inode_ref,
 		ext4_extent_index_t *index)
 {
@@ -571,5 +571,5 @@
 	
 	block_t* block;
-	errno_t rc = block_get(&block, inode_ref->fs->device, fblock, BLOCK_FLAGS_NONE);
+	int rc = block_get(&block, inode_ref->fs->device, fblock, BLOCK_FLAGS_NONE);
 	if (rc != EOK)
 		return rc;
@@ -618,10 +618,10 @@
  *
  */
-errno_t ext4_extent_release_blocks_from(ext4_inode_ref_t *inode_ref,
+int ext4_extent_release_blocks_from(ext4_inode_ref_t *inode_ref,
     uint32_t iblock_from)
 {
 	/* Find the first extent to modify */
 	ext4_extent_path_t *path;
-	errno_t rc = ext4_extent_find_extent(inode_ref, iblock_from, &path);
+	int rc = ext4_extent_find_extent(inode_ref, iblock_from, &path);
 	if (rc != EOK)
 		return rc;
@@ -736,5 +736,5 @@
 	;
 
-	errno_t rc2 = EOK;
+	int rc2 = EOK;
 
 	/*
@@ -767,5 +767,5 @@
  *
  */
-static errno_t ext4_extent_append_extent(ext4_inode_ref_t *inode_ref,
+static int ext4_extent_append_extent(ext4_inode_ref_t *inode_ref,
     ext4_extent_path_t *path, uint32_t iblock)
 {
@@ -785,5 +785,5 @@
 			/* Full node - allocate block for new one */
 			uint32_t fblock;
-			errno_t rc = ext4_balloc_alloc_block(inode_ref, &fblock);
+			int rc = ext4_balloc_alloc_block(inode_ref, &fblock);
 			if (rc != EOK)
 				return rc;
@@ -863,5 +863,5 @@
 	if (entries == limit) {
 		uint32_t new_fblock;
-		errno_t rc = ext4_balloc_alloc_block(inode_ref, &new_fblock);
+		int rc = ext4_balloc_alloc_block(inode_ref, &new_fblock);
 		if (rc != EOK)
 			return rc;
@@ -964,5 +964,5 @@
  *
  */
-errno_t ext4_extent_append_block(ext4_inode_ref_t *inode_ref, uint32_t *iblock,
+int ext4_extent_append_block(ext4_inode_ref_t *inode_ref, uint32_t *iblock,
     uint32_t *fblock, bool update_size)
 {
@@ -982,5 +982,5 @@
 	/* Load the nearest leaf (with extent) */
 	ext4_extent_path_t *path;
-	errno_t rc = ext4_extent_find_extent(inode_ref, new_block_idx, &path);
+	int rc = ext4_extent_find_extent(inode_ref, new_block_idx, &path);
 	if (rc != EOK)
 		return rc;
@@ -1088,5 +1088,5 @@
 	;
 
-	errno_t rc2 = EOK;
+	int rc2 = EOK;
 
 	/* Set return values */
